/* pam_start.c */

#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "pam_appl.h"
#include "pam_private.h"

int pam_start (
    char *service_name,
    char *user,
    struct pam_conv *pam_conversation,
    pam_handle_t **pamh)
{
    /* We require that the service_name and user be specified */
    if ((! service_name) || (! *service_name)) {
        *pamh = NULL;
        return PAM_UNKOWN_SERVICE;
    }
    if ((! user) || (! *user)) {
        *pamh = NULL;
        return PAM_BAD_USER;
    }
    
    *pamh = malloc(sizeof(**pamh));

    (*pamh)->service_name = strdup(service_name);
    (*pamh)->user = strdup(user);
    (*pamh)->tty = NULL;
    (*pamh)->ruser = NULL;
    (*pamh)->rhost = NULL;
    (*pamh)->authtok = NULL;
    (*pamh)->oldauthtok = NULL;
    (*pamh)->pam_conversation = pam_conversation;
    (*pamh)->data = NULL;

    (*pamh)->handlers.module = NULL;
    _pam_init_handlers(*pamh);
    
    return PAM_SUCCESS;
}


